﻿const co = require('co');
const helper = require("./../index");

co(function *() {
  const answer = yield helper.questionAsync('Say something: ');
  helper.logSucceed(answer);

  if (yield helper.yesNoAsync('Yes or no?')) helper.logSucceed('Yes!');
  else helper.logSucceed('No');

  if (yield helper.noYesAsync('No or yes?')) helper.logSucceed('Yes!');
  else helper.logSucceed('No');

  const items = [{ id: 1, name: 'AHD' }, { id: 2, name: 'UIO' }, { id: 3, name: 'NGB' }, { id: 4, name: 'CVS' }];

  let [index, item] = yield helper.chooseFromAsync(items, 'Which item?');
  helper.logInfoTitle('Choosen:', () => index, () => item);

  [index, item] = yield helper.chooseFromAsync(items, 'Which item?', 'name');
  helper.logInfoTitle('Choosen:', () => index, () => item);

  [index, item] = yield helper.chooseFromAsync(items, 'Which item?', i => `id : ${i.id} - name : ${i.name}`);
  helper.logInfoTitle('Choosen:', () => index, () => item);

  helper.titleStart("Start of testing");
  helper.logEvalInfo("const a = 5, b = 6; a + b;");
  helper.br();
  helper.logEvalInfoTitle("Test logEvalInfoTitle:", "const a = 5, b = 6; a + b;");
  helper.br(3);
  helper.logEvalDangerTitle("Eval error:", "nonexist.b + c;");
  const a = 12, b = 18;
  helper.logInfoTitle("Callback:", "a + b = 30", () => a + b);

  helper.logSucceedTitle("Object:", () => {
    return {
      a: 4,
      b: 5,
      c() {
        return 6;
      }
    };
  });
  helper.logDangerTitle("Error:", () => a[b][c]);
  helper.line("A break line");
  const o = {
    a: {
      b: {
        c: {
          d: {
            e: {
              f: {
                g: 1,
                h: {
                  i: 2
                }
              }
            }
          }
        }
      }
    }
  };
  helper.logSucceedTitle("o", () => o);
  helper.titleEnd("End of testing");
});